%global namedreltag -alpha-9
%global namedversion %{version}%{?namedreltag}

Name:          shrinkwrap-descriptors
Version:       2.0.0
Release:       0.19.alpha9%{?dist}
Summary:       ShrinkWrap sub-project for creating Archive Descriptors
# Some file are without license headers
# reported @ https://github.com/shrinkwrap/descriptors/issues/106
License:       ASL 2.0
Url:           http://arquillian.org/modules/descriptors-shrinkwrap/
Source0:       https://github.com/shrinkwrap/descriptors/archive/%{namedversion}.tar.gz

# Related to SHRINKDESC-137
Patch0:        shrinkwrap-descriptors-2.0.0-alpha-8-saxon9.4.patch

BuildArch:     noarch

BuildRequires: graphviz
BuildRequires: maven-local
BuildRequires: mvn(com.sun.codemodel:codemodel)
BuildRequires: mvn(com.sun.xml.dtd-parser:dtd-parser)
BuildRequires: mvn(com.thoughtworks.qdox:qdox)
BuildRequires: mvn(commons-logging:commons-logging)
BuildRequires: mvn(dom4j:dom4j)
BuildRequires: mvn(jdepend:jdepend)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(net.sf.saxon:saxon)
BuildRequires: mvn(org.apache.ant:ant)
BuildRequires: mvn(org.apache.ant:ant-testutil)
BuildRequires: mvn(org.apache.commons:commons-lang3)
BuildRequires: mvn(org.apache.maven:maven-core)
BuildRequires: mvn(org.apache.maven:maven-plugin-api)
#BuildRequires: mvn(org.apache.maven.plugins:maven-checkstyle-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-clean-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-enforcer-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-plugin-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-release-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-source-plugin)
BuildRequires: mvn(org.apache.maven.plugin-testing:maven-plugin-testing-harness)
BuildRequires: mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires: mvn(org.codehaus.mojo:buildnumber-maven-plugin)
BuildRequires: mvn(org.jboss:jboss-parent:pom:)
BuildRequires: mvn(org.jboss.apiviz:apiviz)
BuildRequires: mvn(org.mockito:mockito-all)
BuildRequires: mvn(xmlunit:xmlunit)

%description
ShrinkWrap sub-project for creating Archive Descriptors

This package contains the ShrinkWrap Descriptors API Base.
API Base for Client View of the ShrinkWrap Descriptors Project.

%package ant
Summary:       ShrinkWrap Descriptors Ant Extension

%description ant
Extension module for ShrinkWrap Descriptors Ant Tasks.

%package api-javaee
Summary:       ShrinkWrap Descriptors Generated Java EE API

%description api-javaee
Client View of the ShrinkWrap Descriptors Project.

%package api-javaee-prototype
Summary:       ShrinkWrap Descriptors Prototype Java EE API

%description api-javaee-prototype
Client View of the ShrinkWrap Descriptors Project.

%package api-jboss
Summary:      ShrinkWrap Descriptors Generated JBoss API

%description api-jboss
Client View of the JBoss related ShrinkWrap Descriptors Project.

%package api-misc
Summary:      ShrinkWrap Descriptors Generated Misc API

%description api-misc
Client View of the ShrinkWrap Descriptors Project.

%package bom
Summary:      ShrinkWrap Descriptors Bill of Materials

%description bom
Centralized dependency Management for the
ShrinkWrap Descriptors Project.

%package build-resources
Summary:      Shrinkwrap Descriptors Build Resources

%description build-resources
Shrinkwrap Descriptors Build Resources.

%package depchain
Summary:      ShrinkWrap Descriptors Dependency Chain

%description depchain
Single-POM Definition to export the ShrinkWrap Descriptors
artifacts in proper scope.

%package gen
Summary:       ShrinkWrap Descriptors Source Generator

%description gen
Generates various deployment descriptors via XSLT transformation.

%package impl-base
Summary:       ShrinkWrap Descriptors Implementation
# LGPLv2: ./impl-base/src/main/java/org/jboss/shrinkwrap/descriptor/impl/base/Strings.java
License:       ASL 2.0 and LGPLv2+

%description impl-base
Implementation of the ShrinkWrap Descriptors Project.

%package impl-javaee
Summary:       ShrinkWrap Descriptors Generated Java EE Implementation

%description impl-javaee
Generated Implementation of the ShrinkWrap Descriptors Project.

%package impl-javaee-prototype
Summary:       ShrinkWrap Descriptors Prototype Java EE Implementation

%description impl-javaee-prototype
Prototype Implementation of the ShrinkWrap Descriptors Project.

%package impl-jboss
Summary:       ShrinkWrap Descriptors Generated JBoss Implementation

%description impl-jboss
Generated JBoss Implementation of the ShrinkWrap Descriptors Project.

%package impl-misc
Summary:       ShrinkWrap Descriptors Generated Misc Implementation

%description impl-misc
Generated JBoss Implementation of the ShrinkWrap Descriptors Project.

%package metadata-parser
Summary:       ShrinkWrap Descriptors Metadata Parser

%description metadata-parser
XSD and DTD parser for the ShrinkWrap Descriptors.

%package metadata-parser-test
Summary:       ShrinkWrap Descriptors Metadata Parser Tests

%description metadata-parser-test
Hand-coded Tests for the generated descriptors via metadata plugin.

%package parent
Summary:       ShrinkWrap Descriptors Aggregator POM

%description parent
ShrinkWrap Descriptors Aggregator POM.

%package spi
Summary:       ShrinkWrap Descriptors SPI

%description spi
Service Provider Interface of the ShrinkWrap Descriptors Project.

%package test-util
Summary:       ShrinkWrap Descriptors Test Utilities

%description test-util
Commonly used custom assertions.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n descriptors-%{namedversion}
%patch0 -p1
rm -r gen/doc/*

%pom_remove_plugin -r :maven-checkstyle-plugin

# saxon-dom is built in saxon in Fedora
%pom_remove_dep :saxon-dom metadata-parser
# Unavailable test dep
%pom_remove_dep -r org.easytesting:fest-assert

# Do not build test module, which is only for tests
%pom_disable_module test

# java.lang.NoClassDefFoundError: org/apache/maven/execution/MavenExecutionResult
%pom_add_dep org.apache.maven:maven-core::test metadata-parser

# Remove classpath in MANIFEST files
%pom_xpath_set -r "pom:addClasspath" false ant metadata-parser

# testConfiguration(org.jboss.shrinkwrap.descriptor.metadata.mojo.MetadataParserMojoTest)  Time elapsed: 1.212 sec  <<< ERROR!
# org.codehaus.plexus.component.repository.exception.ComponentLookupException: 
#java.util.NoSuchElementException
#      role: org.apache.maven.repository.RepositorySystem
rm metadata-parser/src/test/java/org/jboss/shrinkwrap/descriptor/metadata/mojo/MetadataParserMojoTest.java


%mvn_package :%{name}-impl-base::tests: %{name}-impl-base

%build

export JAVA5_HOME=%{_jvmdir}/java
%mvn_build -s

%install
%mvn_install

%files -f .mfiles-%{name}-api-base
%license LICENSE

%files ant -f .mfiles-%{name}-ant
%files api-javaee -f .mfiles-%{name}-api-javaee
%files api-javaee-prototype -f .mfiles-%{name}-api-javaee-prototype
%files api-jboss -f .mfiles-%{name}-api-jboss
%files api-misc -f .mfiles-%{name}-api-misc

%files bom -f .mfiles-%{name}-bom
%license LICENSE

%files build-resources -f .mfiles-%{name}-build-resources
%license LICENSE

%files depchain -f .mfiles-%{name}-depchain
%license LICENSE

%files gen -f .mfiles-%{name}-gen
%doc gen/readme.txt
%license LICENSE

%files impl-base -f .mfiles-%{name}-impl-base
%files impl-javaee -f .mfiles-%{name}-impl-javaee
%files impl-javaee-prototype -f .mfiles-%{name}-impl-javaee-prototype
%files impl-jboss -f .mfiles-%{name}-impl-jboss
%files impl-misc -f .mfiles-%{name}-impl-misc
%files metadata-parser -f .mfiles-%{name}-metadata-parser
%files metadata-parser-test -f .mfiles-%{name}-metadata-parser-test

%files parent -f .mfiles-%{name}-parent
%license LICENSE

%files spi -f .mfiles-%{name}-spi

%files test-util -f .mfiles-%{name}-test-util
%license LICENSE

%files javadoc -f .mfiles-javadoc
%license LICENSE

%changelog
* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-0.19.alpha9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-0.18.alpha9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Jun 21 2016 gil cattaneo <puntogil@libero.it> 2.0.0-0.17.alpha9
- add missing build requires

* Mon Mar 21 2016 gil cattaneo <puntogil@libero.it> 2.0.0-0.16.alpha9
- update to 2.0.0-alpha-9

* Wed Mar 09 2016 gil cattaneo <puntogil@libero.it> 2.0.0-0.15.alpha8
- fix impl-base license field

* Wed Mar 09 2016 gil cattaneo <puntogil@libero.it> 2.0.0-0.14.alpha8
- update to 2.0.0-alpha-8

* Mon Feb 15 2016 gil cattaneo <puntogil@libero.it> 2.0.0-0.13.alpha2
- fix FTBFS rhbz#1308127
- fix BR list and use BR mvn()-like
- use pom macros
- fix some rpmlint problem

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.0-0.12.alpha2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.0-0.11.alpha2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue Jun 24 2014 Lin Gao <lgao@redhat.com> - 2.0.0-0.10.alpha2
- Use BuildRequires: junit and BuildRequires: maven-surefire-provider-junit for f21 target(#1107301)

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.0-0.9.alpha2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 2.0.0-0.8.alpha2
- Use Requires: java-headless rebuild (#1067528)

* Mon Aug 12 2013 Marek Goldmann <mgoldman@redhat.com> - 2.0.0-0.7.alpha2
- Fixed missing BuildArch

* Tue Aug 06 2013 Marek Goldmann <mgoldman@redhat.com> - 2.0.0-0.6.alpha2
- New guidelines

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.0-0.5.alpha2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.0-0.4.alpha2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 2.0.0-0.3.alpha2
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.0-0.2.alpha2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed May 23 2012 Lin Gao <lgao@redhat.com> 2.0.0-0.1.alpha2
- initial rpm
